<template>

  <div>
    <v-toolbar small dense class="mt-2 mb-2 elevation-0"  dark color="transparent">
         <v-btn ripple small dark class="elevation-1" color="primary" @click="dialog = true">
            <v-icon>add</v-icon>
            <span >{{$i18n.t("interview.actions.add.text")}}</span>
         </v-btn>
         <v-spacer/>
         <span style="opacity: .5">{{$i18n.tc("interview.count", root.interviews.length)}}</span>
    </v-toolbar>
  
    <v-layout row>
        <v-flex xs12>
            <InterviewCard 
                :key="interview.id"
                v-for="(interview, index) in interviews"
                class="mb-2" :interview="interview" 
                :application="application" 
                @delete="deleteInterview(interview, index)"></InterviewCard>
        </v-flex>
    </v-layout>
      
    <v-layout row v-if="interviews.length == 0">
        <v-flex xs12 class="text-xs-center mt-5 headline" style="color: rgba(255, 255, 255, .8); text-weight: thin">
           {{$i18n.t("interview.actions.add.description")}}   
        </v-flex>
    </v-layout>
    
    
    <v-layout row justify-center>
        <v-dialog v-model="dialog" persistent fullscreen hide-overlay transition="dialog-bottom-transition">
            <InterviewForm @cancel="dialog=false" @save="addInterview"/>
        </v-dialog>
    </v-layout>
  </div>
</template>

<script>
import moment from 'moment'
import InterviewCard from './InterviewCard'
import InterviewForm from '../forms/InterviewForm'
export default {
    name: 'InterviewList',
    props: {
        application: Object,
        
    },
    components: {InterviewCard, InterviewForm},
    data() {
        return {
            dialog: null,
            root: this.application,
            interviews: this.application.interviews.sort((a, b) => moment(b.date).valueOf() - moment(a.date || new Date()).valueOf() )
        }
    },
    methods: {
        async addInterview(interview) {
            this.dialog = false
            const newInterview = Object.assign({}, interview)
            this.application.interviews.splice(0, 0, newInterview)
            const saved = await this.$api.createInterview(this.application.id, interview)
            this.application.interviews.splice(0, 1, saved)
            this.application.interviews.sort((a, b) => moment(b.date).valueOf() - moment(a.date || new Date()).valueOf() )
        },
        async deleteInterview(interview, index) {
             try {
                this.root.interviews.splice(index, 1);
                await this.$api.deleteInterview(this.application.id, interview);
            }
            catch (e) {
                this.root.interviews.splice(index, 0, interview)
                this.$logger.error("error deleting interview", e.message)
                this.error('Could not delete interview')
            } 
        },
        error(message) {
            this.$emit('error', {
                message,
                color: 'error'
            })
        }
    }
}
</script>